﻿Imports System.Globalization
Imports System.Threading
Imports System.Text.RegularExpressions
Imports System.Runtime.CompilerServices

Module StringExtensions
    ' Convert the string to Pascal case.
    <Extension()> _
    Public Function ToPascalCase(ByVal the_string As String) As String
        Dim info As TextInfo = Thread.CurrentThread.CurrentCulture.TextInfo
        the_string = info.ToTitleCase(the_string)
        Dim parts() As String = the_string.Split(New Char() {}, _
            StringSplitOptions.RemoveEmptyEntries)
        Dim result As String = String.Join(String.Empty, parts)
        Return result
    End Function

    ' Convert the string to camel case.
    <Extension()> _
    Public Function ToCamelCase(ByVal the_string As String) As String
        the_string = the_string.ToPascalCase()
        Return the_string.Substring(0, 1).ToLower() + the_string.Substring(1)
    End Function

    ' Capitalize the first character and add a space before
    ' each capitalized letter (except the first character).
    <Extension()> _
    Public Function ToProperCase(ByVal the_string As String) As String
        Const pattern As String = "(?<=\w)(?=[A-Z])"
        'Const pattern As String = "(?<=[^A-Z])(?=[A-Z])"
        Dim result As String = Regex.Replace(the_string, pattern, " ", RegexOptions.None)
        Return result.Substring(0, 1).ToUpper() + result.Substring(1)
    End Function
End Module
